# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

# https://pip.pypa.io/en/stable/topics/caching/
cache:
  paths:
    - .cache/pip

stages:
  - lint
  - test

.python-req:
  image: python:3.11
  before_script:
    - python --version ; pip --version  # For debugging
    - pip install virtualenv
    - virtualenv venv
    - source venv/bin/activate

test:
  extends: [.python-req]
  stage: test 
  before_script:
    # [🦊] hint: Root cause analysis.
    # Solution 1: Install redis using pip
    - pip install redis
    # Solution 2: Add redis to requirements.txt, use pip
    - pip install -r requirements.txt 
    
  script:
    - python src/main.py

  # Solution 3 - Running Redis
  services:
    - redis

# [🦊] hint: Root cause analysis.
# Solution 4, advanced:
# Add a specific lint job with better error reporting
# lint:
#   extends: [.python-req]
#   stage: lint
#   before_script:
#     - pip install -r requirements.txt
#   script:
#     - pylint src/*.py    